#define MEM 0x800000
#include<cstdlib>
#include<cstdio>
#include<cstring>
#include<string>
using namespace std;
typedef unsigned short U1;
typedef unsigned char U8;
typedef unsigned int U3;
template<class T,int a=0>class Array{
public:
U8*ptr;
T*data;
int n;
Array(int i){
ptr=(U8*)calloc(a+i*sizeof(T),1);
if(!ptr)throw("Buy memory");
n=i;
if(a)ptr+=a-((long)ptr&(a-1));
data=(T*)ptr;
}
T&operator[](int i){
return data[i];
}
};
int y,tf,zf,pos,bpos,fnu,order,b1,b2,b3,tt,c4,x4,w4,w5,c0=1,pr=2048,dt[1024];
class Random{
public:
U3 i,t[64];
Random(){
t[0]=123456789;
t[1]=987654321;
for(i=0;i<62;i++)
t[i+2]=t[i+1]*11+t[i]*23/16;
for(i=0;i<1024;i++)
dt[i]=16384/(i*2+3);
i=0;
}
U3 operator()(){
return ++i,t[i&63]=t[i-24&63]^t[i-55&63];
}
}rnd;
class Buf{
public:
U8 b[0x400000];
U8 &operator[](int i){
return b[i&0x3fffff];
}
int operator()(int i){
return b[pos-i&0x3fffff];
}
}buf;
class Ilog{
public:
U8 t[65536];
int operator()(U1 x){
return t[x];
}
Ilog(){
U3 x=0xd80000;
for(int i=2;i<65536;i++)
x+=774541002/(i*2-1),t[i]=x>>24;
}
}ilog;
int llog(U3 x){
if(x>>16)
return ilog(x>>8)+128;
return ilog(x);
}
U8 sta[256][4]={
#include"c"
};
#define nex(s,c)sta[c][s]
int squash(int i){
static int t[]={
1,2,3,6,10,16,27,45,73,120,194,310,488,747,1101,
1546,2047,2549,2994,3348,3607,3785,3901,3975,4022,
4050,4068,4079,4085,4089,4092,4093,4094};
if(i>2047)
return 4095;
if(i<-2047)
return 0;
int w=i&127;
i=(i>>7)+16;
return (t[i]*(128-w)+t[i+1]*w+64)>>7;
}
class Stretch{
public:
short t[4096];
Stretch(){
int j=0;
for(int x=-2047;x<=2047;++x)
for(int i=squash(x);j<=i;++j)
t[j]=x;
t[4095]=2047;
}
int operator()(int p){
return t[p];
}
}stretch;
int dot_product(short*t,short*w,int n){
int s=0;
n=n+7&-8;
for(int i=0;i<n;i+=2)
s+=(t[i]*w[i]+t[i+1]*w[i+1])>>8;
return s;
}
class Mixer{
public:
int N,M,S,nc,base,nx;
Array<short,16>t,w;
Array<int>cxt,pr;
Mixer*mp;
void init(){
int i;
for(i=0;i<S;i++)
pr[i]=2048;
for(i=0;i<N*M;i++)
w[i]=0;
if(S>1)
mp->init();
}
Mixer(int n,int m,int s):N(n+7&-8),M(m),S(s),t(N),w(N*M),cxt(S),pr(S){
nx=base=nc=0;
if(S>1)
mp=new Mixer(S,1,1);
init();
}
void update(){
nx=nx+7&-8;
for(int i=0;i<nc;i++){
int e=((y<<12)-pr[i])*7;
short*p=&w[cxt[i]*N];
for(int j=0;j<nx;++j){
int c=p[j]+(((t[j]*e>>15)+1)>>1);
if(c<-32768)c=-32768;
if(c>32767)c=32767;
p[j]=c;
}
}
nx=base=nc=0;
}
void add(int x){
t[nx++]=x;
}
void set(int cx,int r){
cxt[nc++]=base+cx;
base+=r;
}
int p(){
while(nx&7)t[nx++]=0;
if(S>1){
mp->update();
for(int i=0;i<nc;i++)
pr[i]=squash(dot_product(&t[0],&w[cxt[i]*N],nx)>>5),mp->add(stretch(pr[i]));
mp->set(0,1);
return mp->p();
}
return pr[0]=squash(dot_product(&t[0],&w[0],nx)>>8);
}
};
class APM{
public:
int i,n;
Array<U1>t;
APM(int c):i(0),n(c-1),t(c*33){
for(int i=0;i<c;i++)
for(int j=0;j<33;++j)
t[i*33+j]=i?t[j]:squash((j-16)*128)*16;
}
int p(int pr,int c,int r){
pr=stretch(pr);
int g=(y<<16)+(y<<r)-y-y;
t[i]+=(g-t[i])>>r;
t[i+1]+=(g-t[i+1])>>r;
int w=pr&127;
i=((pr+2048)>>7)+(c&n)*33;
return (t[i]*(128-w)+t[i+1]*w)>>11;
}
};
class SMap{
public:
U3 cxt,t[256];
void init(){
cxt=0;
for(int i=0;i<256;i++)
t[i]=1<<31;
}
SMap(){
init();
}
int p(int cx){
U3*p=&t[cxt],p0=p[0];
int pr=p0>>10,n=p0&1023;
p0+=(n<1023);
p0+=(((y<<22)-pr)>>3)*dt[n]&0xfffffc00;
p[0]=p0;
return t[cxt=cx]>>20;
}
};
U3 hash(U3 a,U3 b,U3 c=-1){
U3 h=a*200002979+b*30005491+c*50004239-180007306;
return h^h>>9^a>>2^b>>3^c>>4;
}
int mix2(Mixer&m,int s,SMap&sm){
int p1=sm.p(s);
int p0=4095-p1;
int n0=-!nex(2,s);
int n1=-!nex(3,s);
int st=stretch(p1);
m.add(st/4);
m.add((p1-p0)/32);
m.add(st*(n1-n0)/4);
m.add(((p1&n0)-(p0&n1))/16);
m.add(((p0&n0)-(p1&n1))*3/32);
return s>0;
}
class CMap{
public:
class E{
public:
U1 chk[7];
U8 last,bh[7][7];
U8*get(U1 ch){
if(chk[last&15]==ch)
return &bh[last&15][0];
int b=0xffff,bi=0;
for(int i=0;i<7;i++){
if(chk[i]==ch)
return last=last*16+i,&bh[i][0];
int pri=bh[i][0];
if(pri<b&&(last&15)!=i&&last>>4!=i)b=pri,bi=i;
}
return last=bi+240,chk[bi]=ch,(U8*)memset(&bh[bi][0],0,7);
}
};
Array<E,64>t;
Array<U8*>cp,cp0,runp;
Array<U3>cxt;
SMap*sm;
int C,cn;
int mix(Mixer&m){
if(zf){
memset((U8*)&t[0],0,t.n*64);
for(int i=0;i<C;i++)
sm[i].init();
}
int res=0;
for(int i=0;i<cn;i++){
U8 *r=runp[i];
if(cp[i]){
int ns=nex(y,*cp[i]);
if(ns>203&&rnd()<<(452-ns>>3))ns-=4;
*cp[i]=ns;
}
if(bpos>1&&r[0]==0)cp[i]=0;
else
switch(bpos){
case 1:
case 3:
case 6:cp[i]=cp0[i]+1+(c0&1);break;
case 4:
case 7:cp[i]=cp0[i]+3+(c0&3);break;
case 2:
case 5:cp0[i]=cp[i]=t[(cxt[i]+c0)&(t.n-1)].get(cxt[i]>>16);break;
default:{
cp0[i]=cp[i]=t[(cxt[i]+c0)&(t.n-1)].get(cxt[i]>>16);
if(cp[i][3]==2){
int c=cp0[i][4]+256;
U8*p=t[(cxt[i]+(c>>6))&(t.n-1)].get(cxt[i]>>16);
p[0]=1+(c>>5&1);
p[p[0]]=1+(c>>4&1);
p[3+(c>>4&3)]=1+(c>>3&1);
p=t[(cxt[i]+(c>>3))&(t.n-1)].get(cxt[i]>>16);
p[0]=1+(c>>2&1);
p[p[0]]=1+(c>>1&1);
p[3+(c>>1&3)]=1+(c&1);
cp0[i][6]=0;
}
if(r[0]==0)r[0]=2,r[1]=b1;
else
if(r[1]!=b1)r[0]=1,r[1]=b1;
else
if(r[0]<254)r[0]+=2;
else
if(r[0]==255)r[0]=128;
runp[i]=r=cp0[i]+3;
}
}
if((r[1]+256)>>(8-bpos)==c0)m.add(((r[1]>>(7-bpos)&1)*2-1)*(ilog(r[0]+1)<<(3-(r[0]&1))));
else
m.add(0);
if(cp[i])res+=mix2(m,*cp[i],sm[i]);
else
mix2(m,0,sm[i]);
}
if(bpos==7)cn=0;
return res;
}
CMap(int m,int c=3):C(c),t(m>>6),cp(c),cp0(c),cxt(c),runp(c),cn(0){
sm=new SMap[C];
for(int i=0;i<C;i++)
cp0[i]=cp[i]=&t[0].bh[0][0],runp[i]=cp[i]+3;
}
void set(U3 cx){
int i=cn++;
cx=cx*987654323+i;
cx=cx<<16|cx>>16;
cxt[i]=cx*123456791+i;
}
};
int h,ptr,len,res;
int matchm(Mixer&m){
static CMap cm(0x20000,1);
static Array<int>t(MEM);
if(!bpos){
h=(h*7976+b1+1)&(t.n-1);
if(len)++len,++ptr;
else{
ptr=t[h];
if(ptr)
while(buf(len+1)==buf[ptr-len-1]&&len<65534)++len;
}
t[h]=pos;
res=len;
cm.set(pos);
}
int v1=0,v2=0;
if(len){
if(b1==buf[ptr-1]&&c0==(buf[ptr]+256)>>(8-bpos)){
if(len>65534)len=65534;
v1=ilog(len)<<2,v2=min(len,32)<<6;
if(!(buf[ptr]>>(7-bpos)&1))v1=-v1,v2=-v2;
}
else
len=0;
}
m.add(v1);
m.add(v2);
cm.mix(m);
return res;
}
void picm(Mixer&m){
static U3 r0,r1,r2,r3,cxt[3];
static Array<U8>t(0x10200);
static SMap sm[3];
int i;
for(i=0;i<3;i++)
t[cxt[i]]=nex(y,t[cxt[i]]);
r0+=r0+y;
r1+=r1+(buf(215)>>(7-bpos)&1);
r2+=r2+(buf(431)>>(7-bpos)&1);
r3+=r3+(buf(647)>>(7-bpos)&1);
cxt[0]=r0&7|r1>>4&56|r2>>3&192;
cxt[1]=256+(r0&1|r1>>4&62|r2>>2&64|r3>>1&128);
cxt[2]=512+(r0&63^r1&0x3ffe^r2<<2&0x7f00^r3<<5&0xf800);
for(i=0;i<3;i++)
m.add(stretch(sm[i].p(t[cxt[i]])));
}
U3 wordlen,wordlen1,frstchar,spafdo,spaces,spacecount;
U3 word0,word1,word2,word3,word4,word5,number0,number1,text0,words,wordcount;
int nl1=-3,nl=-2;
void wordm(Mixer&m){
static CMap cm(MEM*32,40);
if(!bpos){
int c=tolower(b1);
spacecount-=spaces>>31;
wordcount-=words>>31;
spaces*=2;
words*=2;
if((c>='a'&&c<='z')||c>127){
++words,++wordcount;
word0=word0*263*16+c;
text0=text0*997*16+c;
wordlen+=(wordlen<45);
}
else
if(word0){
word5=word4*23;
word4=word3*19;
word3=word2*17;
word2=word1*13;
word1=word0*11;
wordlen1=wordlen;
word0=wordlen=0;
}
if(c>='0'&&c<='9')
number0=number0*263*32+c;
else
if(number0){
number1=number0*11;
number0=0;
}
if(c=='.'||c=='!'||c=='?'||c==';'||c==':')spafdo=0;
else
spafdo+=(spafdo<63);
if(c==32||c=='\n'||c==7){
++spaces,++spacecount;
if(c<32)nl1=nl,nl=pos-1;
}
int col=min(255,pos-nl),above=buf[nl1+col];
if(col<=2)frstchar=(col==2?min(c,96):0);
cm.set(spafdo|col<<8);
cm.set(spafdo|spaces<<8);
cm.set(frstchar<<11|c);
cm.set(col<<8|frstchar);
cm.set(spaces<<8|(words&255));
cm.set(number0+word2*31);
cm.set(number0+word1*31);
cm.set(number0*31+c);
cm.set(number0+number1*31);
cm.set(word0+number1*31);
cm.set(frstchar<<7);
cm.set(wordlen<<16|c);
cm.set(wordlen1<<8|col);
cm.set(c*64+spacecount/2);
U3 d=c4&0xffff,h=wordcount*64+spacecount;
cm.set(c<<13|h);
cm.set(h);
cm.set(h+spafdo*8);
cm.set(d<<9|frstchar);
h=word0*271+b1;
cm.set(h);
cm.set(word0);
cm.set(h+word1);
cm.set(word0+word1*31);
cm.set(h+word1+word2*29);
cm.set(text0&0xffffff);
cm.set(text0&0xfffff);
cm.set(h+word2);
cm.set(h+word3);
cm.set(h+word4);
cm.set(h+word5);
cm.set(b1|buf(3)<<8|buf(5)<<16);
cm.set(buf(2)|buf(4)<<8|buf(6)<<16);
cm.set(h+word1+word3);
cm.set(h+word2+word3);
cm.set(col<<16|b1<<8|above);
cm.set(b1<<8|above);
cm.set(col<<8|b1);
cm.set(col*(c==32));
cm.set(col);
}
cm.mix(m);
}
void sparsem(Mixer&m){
static CMap cm(MEM*2,40);
if(!bpos){
cm.set(pr);
cm.set(order);
cm.set(b1|buf(5)<<8);
cm.set(b1|buf(6)<<8);
cm.set(buf(3)|buf(6)<<8);
cm.set(buf(4)|buf(8)<<8);
cm.set(c4&0xf0f0ff);
cm.set(c4&0xff00ff);
cm.set(c4&0xff0000ff);
cm.set(c4&0xf8f8f8);
cm.set(c4&0xf8f8f8f8);
cm.set(c4&0xf0f0f0);
cm.set(c4&0xf0f0f0f0);
cm.set(c4&0xe0e0e0);
cm.set(c4&0xe0e0e0e0);
cm.set(c4&0x810000c1);
cm.set(c4&0xc3ccc38c);
cm.set(c4&0x81cc81);
cm.set(c4&0xc10081);
for(int i=1;i<8;i++){
cm.set(pr|buf(i)<<8);
cm.set(buf(i+2)<<8|buf(i+1));
cm.set(buf(i+3)<<8|buf(i+1));
}
}
cm.mix(m);
}
int pos00,pos20,posnl;
void distancem(Mixer&m){
static CMap cm(MEM);
if(!bpos){
int c=b1;
if(c==0)pos00=pos;
if(c==32)pos20=pos;
if(c==255||c==13||c=='\n')posnl=pos;
cm.set(min(255,pos-pos00)|(c<<8));
cm.set(min(255,pos-pos20)|(c<<8));
cm.set(min(255,pos-posnl)|((c<<8)+234567));
}
cm.mix(m);
}
U3 t1[256];
U1 t2[65536],t3[32768];
void indirectm(Mixer&m){
static CMap cm(MEM,9);
if(!bpos){
U3 d=c4&0xffff,c=b1,w=(buf(2)&31)+(buf(3)&31)*32,&r1=t1[d>>8];
U1 &r2=t2[c4>>8&0xffff],&r3=t3[w+(buf(4)&31)*1024];
r1=r1<<8|c;
r2=r2<<8|c;
r3=r3<<8|c;
w=(c&31)+w*32;
U3 t=c|t1[c]<<8,t0=d|t2[d]<<16,ta=w|t3[w]<<16;
cm.set(t);
cm.set(t0);
cm.set(ta);
cm.set(t&0xff00);
cm.set(t0&0xff0000);
cm.set(ta&0xff0000);
cm.set(t&0xffff);
cm.set(t0&0xffffff);
cm.set(ta&0xffffff);
}
cm.mix(m);
}
int cpos1[256],cpos2[256],cpos3[256],cpos4[256],wpos1[65536],rlen=2,rlen1=3,rlen2=4,rcount1,rcount2;
void recordm(Mixer&m){
static CMap cm(32768),cn(32768/2),co(32768*2),cp(MEM);
if(!bpos){
U3 d=c4&0xffff,c=b1,w=d>>8;
int r=pos-cpos1[c];
if(r>1&&r==cpos1[c]-cpos2[c]&&r==cpos2[c]-cpos3[c]&&r==cpos3[c]-cpos4[c]&&(r>15||((c==buf(r*5+1))&&c==buf(r*6+1)))){
if(r==rlen1)++rcount1;
else
if(r==rlen2)++rcount2;
else
if(rcount1>rcount2)
rlen2=r,rcount2=1;
else
rlen1=r,rcount1=1;
}
if(rcount1>15&&rlen!=rlen1)rlen=rlen1,rcount1=rcount2=0;
if(rcount2>15&&rlen!=rlen2)rlen=rlen2,rcount1=rcount2=0;
int col=pos%rlen;
cm.set(c<<8|(min(255,r)/4));
cm.set(d<<9|llog(pos-wpos1[d])>>2);
cm.set(rlen|buf(rlen)<<10|buf(rlen*2)<<18);
cn.set(d|rlen<<8);
cn.set(w|rlen<<16);
cn.set(c|rlen<<8);
co.set(c<<8|min(255,r));
co.set(c<<17|buf(2)<<9|llog(pos-wpos1[d])>>2);
co.set(c<<8|buf(rlen));
cp.set(rlen|buf(rlen)<<10|col<<18);
cp.set(rlen|c<<10|col<<18);
cp.set(col|rlen<<12);
cpos4[c]=cpos3[c];
cpos3[c]=cpos2[c];
cpos2[c]=cpos1[c];
cpos1[c]=pos;
wpos1[d]=pos;
}
cm.mix(m);
cn.mix(m);
co.mix(m);
cp.mix(m);
}
struct DMCNode{
U3 nx[2];
U8 state;
U3 c0:12,c1:12;
};
int top,threshold=256,curr;
void dmcm(Mixer&m){
static Array<DMCNode>t(MEM/2);
static SMap sm;
if(top>0&&top<t.n){
int i=t[curr].nx[y];
int n=y?t[curr].c1:t[curr].c0;
int nn=t[i].c0+t[i].c1;
if(n>=threshold*2&&nn-n>=threshold*3){
int r=n*4096/nn;
t[i].c0-=t[top].c0=t[i].c0*r>>12;
t[i].c1-=t[top].c1=t[i].c1*r>>12;
t[top].nx[0]=t[i].nx[0];
t[top].nx[1]=t[i].nx[1];
t[top].state=t[i].state;
t[curr].nx[y]=top++;
}
}
if(top==t.n&&bpos==1)
top=0;
if(top==0){
for(int i=0;i<256;i++)
for(int j=0;j<256;++j){
int n=j*256+i;
if(i<127)t[n].nx[0]=n+i+1,t[n].nx[1]=n+i+2;
else
t[n].nx[0]=(i-127)*256,t[n].nx[1]=(i+1)*256;
t[n].c0=t[n].c1=128;
}
top=65536,threshold=256,curr=0;
}
if(y){
if(t[curr].c1<3800)t[curr].c1+=256;
}
else
if(t[curr].c0<3800)t[curr].c0+=256;
t[curr].state=nex(y,t[curr].state);
curr=t[curr].nx[y];
int n1=t[curr].c1;
int n0=t[curr].c0;
m.add(stretch(sm.p(t[curr].state)));
m.add(stretch((n1+5)*4096/(n0+n1+10)));
}
int ic,zc,pc,vc,wc,pvv,mask;
void nestm(Mixer&m){
static CMap cm(MEM*2,11);
if(!bpos){
int c=b1,matched=1,vv,lc=tolower(c);
if(lc=='a'||lc=='e'||lc=='i'||lc=='o'||lc=='u')vv=1;
else
if(lc>='a'&&lc<='z')vv=2;
else
if(lc==32||lc=='.'||lc==','||lc=='\n')vv=3;
else
if(lc>='0'&&lc<='9')vv=4;
else
if(lc=='y')vv=5;
else
if(lc=='\'')vv=6;
else
vv=(c&32)?7:0;
vc=vc*8+vv;
if(vv!=pvv)
wc=wc*8+vv,pvv=vv;
switch(c){
case'(':ic+=513;break;
case')':ic-=513;break;
case'[':ic+=17;break;
case']':ic-=17;break;
case'{':ic+=22;break;
case'}':ic-=22;break;
case'!':pc=0;break;
case'/':pc=0;break;
case':':pc=20;break;
case'\n':pc=0;break;
case'\\':pc+=41;break;
case'\'':pc+=66;break;
case'|':pc+=223;break;
case'"':pc+=64;break;
case'#':pc+=8;break;
case'%':pc+=118;break;
case'$':pc+=69;break;
case'*':pc+=53;break;
case'@':pc+=114;break;
case'=':pc+=87;break;
case'&':
case';':
case 32:break;
default:matched=0;
}
if(matched)zc=0;
else
++zc;
if(zc>300)zc=ic=pc=0;
int fl=0;
if(c){
fl=7;
if(isalpha(c))fl=1;
else
if(ispunct(c))fl=2;
else
if(isspace(c))fl=3;
else
if(c==255)fl=4;
else
if(c<16)fl=5;
else
if(c<64)fl=6;
}
mask=mask<<3|fl;
cm.set((17*pc+7*ic)&0xffff);
cm.set((13*vc+ic)&0xffff);
cm.set((vc*43+pc)&0xfffff);
cm.set(wc&0xffff);
cm.set((vc&0x1fffff)|c<<21);
cm.set((pc&0xffff)|c<<20);
cm.set((ic&0xffff)|c<<16);
cm.set(mask);
cm.set(mask<<8|c);
cm.set(mask<<17|buf(2)<<8|buf(3));
cm.set((mask&0x1ff)|(c4&0xf0f0)<<9);
}
cm.mix(m);
}
U3 pn[]={0,257,251,241,239,233,229,227,223,211,199,197,193,191};
U3 tri[]={0,4,3,7};
U3 trj[]={0,6,6,12};
U3 mpw[]={0,3,3,2,2,2,1,1,1,1,1,1,1,1,1,0};
U3 mtt[]={0,0,1,2,3,4,5,5,6,6,6,6,6,6,6,7};
U3 cxt[16],fails,failz,failcount;
Mixer m(800,10800,8);
APM a1(256),a2(0x8000),a3(0x8000),a4(0x40000),a5(0x10000),a6(0x10000);
void pru(){
static CMap cm(MEM*16,8),cn(MEM*2);
c0+=c0+y;
bpos=bpos+1&7;
if(!bpos){
U8 c=c0;
int i=mpw[c>>4];
c0=1;
b3=b2,b2=b1,b1=buf[pos++]=c,w4=w4*4+i,w5=w5*4+i;
if(tf&&(c=='.'||c=='!'||c=='='||c==')'||c=='/'))
w5=w5<<8|1023,x4=x4<<8|c,w4|=12,b2='.',tt=(tt&-8)+1;
c4=c4<<8|c,x4=x4<<8|c,tt=tt*8+mtt[c-(c==32)>>4];
for(int i=13;i;--i)
cxt[i]=cxt[i-1]*pn[i]+b1;
cm.set(cxt[2]);
cm.set(cxt[3]);
cm.set(cxt[4]);
cm.set(cxt[5]);
cm.set(cxt[6]);
cm.set(cxt[8]);
cm.set(cxt[13]);
cm.set(0);
cn.set(cxt[7]);
cn.set(cxt[9]);
cn.set(cxt[11]);
}
if(fails&128)--failcount;
fails*=2;
failz*=2;
if(y)pr^=4095;
if(pr>1819)++fails,++failcount;
if(pr>847)++failz;
m.update();
m.add(64);
pr=ilog(matchm(m));
cn.mix(m);
order=cm.mix(m)-3;
if(order<0)order=0;
sparsem(m);
recordm(m);
if(fnu<13){
distancem(m);
wordm(m);
indirectm(m);
dmcm(m);
nestm(m);
}
else
picm(m);
zf=0;
U8 d=c0<<(8-bpos),c=d+(bpos==1?b3/2:0)&192;
if(!bpos)c=words*16&192;
m.set(order*256+(w4&240)+(b2>>4),1536);
m.set(order*256+(w4&3)*64+(words>>1&63),1536);
m.set(bpos*256+b1,2048);
m.set(min(bpos,5)*256+(tt&63)+c,1536);
m.set(order*256+((d|b1>>bpos)&248)+bpos,1536);
m.set(bpos*256+((words<<bpos&255)>>bpos|d&255),2048);
m.set(pr,256);
m.set(c0,256);
pr=m.p();
int r=6+tf,pt,pu=a1.p(pr,c0,3)+7*pr+4>>3,pv,pz=1+failcount;
pz+=tri[fails>>5&3];
pz+=trj[fails>>3&3];
pz+=trj[fails>>1&3];
if(fails&1)pz+=8;
pz>>=1;
pu=a4.p(pu,c0*2^hash(b1,x4>>8&255,x4>>16&0x80ff),r);
pv=a2.p(pr,c0*8^hash(29,failz&2047),r+1);
pt=a3.p(pr,c0*32^hash(19,x4&0x80ffff),r);
pz=a6.p(pu,c0*4^hash(min(9,pz),x4&0x80ff),r);
pv=a5.p(pv,hash(c0,w5&0xfffff),r);
if(fails&255)
pr=pt*6+pu+pv*11+pz*14+16>>5;
else
pr=pt*4+pu*5+pv*12+pz*11+16>>5;
}
char*dx[]={
#include"b"
};
int bc,le,sw,et,pf,ff,mt[256],mmt[256];
U3 lc,sp,k,r=-1;
U8 bb[5702];
FILE*rc,*wf;
class Der{
public:
U3 z,x,q,b,p;
Der(){
z=-1;
q=p=0;
for(int i=0;i<40;i++)
x=x*2+in1();
for(int i=0;i<5;i++)
k=k*256+bb[sp++];
}
int in1(){
if(!(p/=2))b=getc(rc),p=128;
return (p&b)>0;
}
int dec(){
U8 c=0;
for(int i=0;i<8;i++){
U3 b=pr*2+1,mid=q+b*(z-q>>13)+(b*(z-q&0x1fff)>>13);
y=0;
if(x<=mid)++y,z=mid;
else
q=mid+1;
pru();
while(1){
b=1<<31;
if(z>=b)
if(q>=b)
x-=b,q-=b,z-=b;
else
if(q>=(b/=2)&&z<-b)
x-=b,q-=b,z-=b;
else
break;
x=x*2+in1();
z=z*2+1;
q*=2;
}
c=c*2+y;
}
if(tf&&(c-43&235)==0)c^=16;
return c;
}
};
void rd(U3 z,U3 c){
k-=z*r;
r=r*c;
while(r<1<<24)k=k*256+bb[sp++],r=r*256;
}
void hp(U3 c){
if(bc>=0){
if(pf&32){
if(pf&1){
for(int i=0;i<256;i++)
mmt[i]=mt[i]=1;
pf--;
}
U3 i=c;
if(!fnu)i=tolower(c),lc=tolower(lc);
if(lc-97>25&&lc!=44&&lc!=46&&lc!=39||i-97>25)bc=32;
else{
if(lc>96&&fnu!=1||lc==44)lc=122;
if(lc<96)lc=125;
int i=min(ff-le,90)/5*12+(lc-97)/3;
if(k/(r/=(mt[i]+mmt[i]))<mt[i])
rd(0,mt[i]),mt[i]+=4,bc=32;
else{
rd(mt[i],mmt[i]),mmt[i]+=4,bc=10;
if(et==0)et=2-(k/(r/=2)<1),rd(et-1,1);
if(et==1)lc=13,++ff,putc(lc,wf);
le=ff;
}
}
}
++ff,putc(bc,wf);
if(c==32){
lc=bc;
bc=c;
return;
}
bc=-1;
}
else
if(c==32){
bc=c;
return;
}
if(c==10)le=ff;
lc=c;
if(c==EOF)
return;
++ff,putc(c,wf);
}
#define nof c=EOF;if(ff<of)c=e.dec();if((pf&8)&&c-77<2)c-=66;
int main(int argc,char**argv){
if(rc=fopen(argv[1],"rb")){
char*p,b[256],*t=b;
fseek(rc,-5702,2);
fread(bb,5702,1,rc);
fseek(rc,0,0);
fread(b,182,1,rc);
Der e;
for(int i=0;i<14;i++){
p=strchr(t,13),*p=0;
if(wf=fopen(strchr(t,9)+1,"wb")){
U3 of=atoi(t),z,i,c,w=0,v=0;
U8 t[256];
lc=et=ff=0;
tf=(fnu<10);
nof;
if(!tf)zf=1,m.init();
le=bc=-1;
pf=c+1;
sw=8;
if(!(pf&72))w=sw=of;
nof;
while(c!=EOF){
if(w){
++ff,putc(c,wf);
if(!(pf&8)&&(c<32&&c!=10&&c!=13||c>127))w=sw;
else
if(!--w)pf|=1;
nof;
}
else
if((pf&64)&&c>127){
if(c>239){
nof;
c+=112;
}
memcpy(t,dx[c-128],z=strlen(dx[c-128]));
if(v&1)--v,t[0]=toupper(t[0]);
if(v&2)
for(i=0;i<z;i++)
t[i]=toupper(t[i]);
for(i=0;i<z;i++)
hp(t[i]);
nof;
}
else
if(c==6){
v=0;
nof;
hp(c);
if(!(pf&8)&&(c<32&&c!=10&&c!=13||c>127))w=sw;
nof;
}
else
if((pf&16)&&c==94){
if(bc==32)bc=-1;
nof;
}
else
if(c==127){
v=1;
nof;
}
else
if(c==12){
v|=2;
nof;
}
else
if(c==11){
v=0;
nof;
if(c==32){
nof;
}
}
else{
if(c==7)hp(13),c=10;
if(v&2)
if(c-97<26)c-=32;
else
v-=2;
else
if(v&1)--v,c=toupper(c);
hp(c);
nof;
}
}
hp(EOF);
++fnu;
}
t=p+2;
}
}
}
